unit Insform;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, DBTables;

type
  TInsertForm = class(TForm)
    NameEdit: TEdit;
    CapitalEdit: TEdit;
    ContinentEdit: TEdit;
    AreaEdit: TEdit;
    PopulationEdit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    InsertBtn: TButton;
    CancelBtn: TButton;
    InsertQuery: TQuery;
    procedure InsertBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  public
    procedure Clear;
  end;

var
  InsertForm: TInsertForm;

implementation

{$R *.DFM}

procedure TInsertForm.Clear;
begin
  ActiveControl := NameEdit;
  NameEdit.Clear;
  CapitalEdit.Clear;
  ContinentEdit.Clear;
  AreaEdit.Clear;
  PopulationEdit.Clear;
end;

procedure TInsertForm.InsertBtnClick(Sender: TObject);
begin
  InsertQuery.Close;
  InsertQuery.Params[0].AsString := NameEdit.Text;
  InsertQuery.Params[1].AsString := CapitalEdit.Text;
  InsertQuery.Params[2].AsString := ContinentEdit.Text;
  try
    InsertQuery.Params[3].AsFloat := StrToFloat(AreaEdit.Text);
  except
    AreaEdit.SelectAll;
    AreaEdit.SetFocus;
    raise;
  end;
  try
    InsertQuery.Params[4].AsFloat := StrToFloat(PopulationEdit.Text);
  except
    PopulationEdit.SelectAll;
    PopulationEdit.SetFocus;
    raise;
  end;
  InsertQuery.ExecSQL;
  ModalResult := mrOK;
end;

procedure TInsertForm.FormCreate(Sender: TObject);
begin
  InsertQuery.Prepare;
end;

end.
